﻿/*
 * PROJECT:   NSudo
 * FILE:      Version.h
 * PURPOSE:   NSudo Version Definition
 *
 * LICENSE:   The MIT License
 *
 * DEVELOPER: Mouri_Naruto (Mouri_Naruto AT Outlook.com)
 */

#include "CIBuild.h"

#ifndef NSUDO_VER
#define NSUDO_VER

#define NSUDO_VER_MAJOR 8
#define NSUDO_VER_MINOR 0
#define NSUDO_VER_PATCH 0

#define NSUDO_VER_TAG_STRING L"alpha2"

#endif

#ifndef NSUDO_VER_FMT_COMMA
#define NSUDO_VER_FMT_COMMA NSUDO_VER_MAJOR,NSUDO_VER_MINOR,NSUDO_VER_PATCH,0
#endif

#ifndef NSUDO_VER_FMT_DOT
#define NSUDO_VER_FMT_DOT NSUDO_VER_MAJOR.NSUDO_VER_MINOR.NSUDO_VER_PATCH.0
#endif

#ifndef NSUDO_VER_FMT_DOT_FOR_SHOW
#define NSUDO_VER_FMT_DOT_FOR_SHOW NSUDO_VER_MAJOR.NSUDO_VER_MINOR.NSUDO_VER_PATCH
#endif


#ifndef MACRO_TO_STRING
#define _MACRO_TO_STRING(arg) L#arg
#define MACRO_TO_STRING(arg) _MACRO_TO_STRING(arg)
#endif

#ifndef NSUDO_VERSION
#define NSUDO_VERSION NSUDO_VER_FMT_COMMA
#endif

#ifndef _NSUDO_VERSION_STRING_
#define _NSUDO_VERSION_STRING_ MACRO_TO_STRING(NSUDO_VER_FMT_DOT)
#endif

#ifndef _NSUDO_VERSION_STRING_FOR_SHOW_
#define _NSUDO_VERSION_STRING_FOR_SHOW_ MACRO_TO_STRING(NSUDO_VER_FMT_DOT_FOR_SHOW) L"-" NSUDO_VER_TAG_STRING
#endif

#ifndef NSUDO_VERSION_STRING
#ifdef NSUDO_CI_BUILD
#define NSUDO_VERSION_STRING _NSUDO_VERSION_STRING_ L" " NSUDO_CI_BUILD
#else
#define NSUDO_VERSION_STRING _NSUDO_VERSION_STRING_
#endif
#endif

#ifndef NSUDO_VERSION_STRING_FOR_SHOW
#ifdef NSUDO_CI_BUILD
#define NSUDO_VERSION_STRING_FOR_SHOW _NSUDO_VERSION_STRING_FOR_SHOW_ L" " NSUDO_CI_BUILD
#else
#define NSUDO_VERSION_STRING_FOR_SHOW _NSUDO_VERSION_STRING_FOR_SHOW_
#endif
#endif
